/*
  Listfile 0.1
  last modified 10/26/2006
  Bryan Steinbach aka PipeDream
 
  Generates a list of all files warcraft extracts from mpqs

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 
 */

/*
 * Changelog:
 * 0.2:
 * Ensure storm is loaded before opening archives
 */

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <map>

typedef BOOL (__stdcall * pSFileGetArchiveName)(long mpq, char *name, DWORD bufsize);
pSFileGetArchiveName SFileGetArchiveName;

std::map<long,char *> archive_name;

char *GetArchiveName(long mpq)
{
	if(archive_name.find(mpq) != archive_name.end()) {
		return archive_name[mpq];
	} else {
		char *s = (char *)malloc(1024);
		SFileGetArchiveName(mpq,s,1024);
		archive_name[mpq] = s;
		return s;
	}
}

void patchbytes(void *dest, void *src, int len)
{
	DWORD old;
	DWORD old2;

	if(!VirtualProtect(dest,len,PAGE_READWRITE,&old)) throw("couldn't set PAGE_READWRITE on page");
	memmove(dest,src,len);
	if(!VirtualProtect(dest,len,old,&old2)) throw("couldn't restore permissions on page");
}

FILE *lfout;
/*
long lastmpq=0;
extern "C" void __cdecl LFHandler(long mpq, char *fn)
{
	if(mpq == 0) {
		if(lastmpq == 0) {
			fprintf(lfout,"unknown %s\n",fn);
		} else {
			fprintf(lfout,"%s %s\n",GetArchiveName(lastmpq),fn);
		}
	} else {
		lastmpq = mpq;
		fprintf(lfout,"%s %s\n",GetArchiveName(mpq),fn);
	}
	fflush(lfout);
}
*/

extern "C" void __cdecl LFHandler(long mpq, char *fn)
{
	fprintf(lfout,"%s\n",fn);
	fflush(lfout);
}

long SFileOpenFileEx;
extern "C" void LFPatch();
extern "C" void LFPatchEnd();
DWORD __stdcall OnStormLoad(LPVOID param)
{
	HMODULE hStorm = NULL;
	while(1) {
		hStorm = GetModuleHandle("storm.dll");
		if(hStorm != NULL) break;
		Sleep(1);
	}

	try {
		long LFPatchSize = (long)LFPatchEnd-(long)LFPatch;
		SFileOpenFileEx = (long)GetProcAddress(hStorm,(char *)268);
		if(!SFileOpenFileEx) throw "Couldn't find SFileOpenFileEx";
		SFileGetArchiveName = (pSFileGetArchiveName)GetProcAddress(hStorm,(char *)275);
		if(!SFileGetArchiveName) throw "Couldn't find SFileGetArchiveName";


		patchbytes((void *)SFileOpenFileEx,(void *)LFPatch,LFPatchSize);

	} catch(const char *err) {
		MessageBox(NULL,err,"ListFile Error",MB_ICONERROR);
	}
	return 0;
}

extern "C" BOOL __stdcall DllMain(HMODULE module, DWORD reason,LPVOID reserved)
{
	if(reason == DLL_PROCESS_ATTACH) {
		lfout = fopen("listfile","w");
		DisableThreadLibraryCalls(module);
		CloseHandle(CreateThread(NULL,16384,OnStormLoad,NULL,0,NULL));
	}
	return true;
}
