/*
  loadmpq 0.2
  last modified 10/24/2006
  Bryan Steinbach aka PipeDream
 
  Loads a list of mpqs one per line in loadmpq.conf with a user specified priority

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 
 */

/*
 * Changelog:
 * 0.2:
 * Ensure storm is loaded before opening archives
 */

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

typedef BOOL __stdcall (* pSFileOpenArchive)(char *fn, long prio, long flags, long *mpq);

pSFileOpenArchive SFileOpenArchive;

char cwd[1024];

void Error(char *e)
{
	MessageBox(NULL,e,"LoadMPQ Error",MB_ICONERROR);
}

void LoadMPQ(HMODULE hStorm)
{
	char buf[1024];
	SFileOpenArchive = (pSFileOpenArchive)GetProcAddress(hStorm,(char *)266);
	if(!SFileOpenArchive) {
		Error("could not open SFileOpenArchive");
		return;;
	}

	int prio;
	char *mpqname = (char *)malloc(4096);
	FILE *conf = fopen("loadmpq.conf","r");
	if(!conf) {
		sprintf(buf,"Please place loadmpq.conf in %s\n",cwd);
		Error(buf);
		return;
	}
	while(fscanf(conf,"%d %4095s\n",&prio,mpqname) > 0) {
		long mpq;
		int ret = SFileOpenArchive(mpqname,prio,0,&mpq);
		if(!ret) {
			sprintf(buf,"Could not open archive %s from %s\n",mpqname,cwd);
			Error(buf);
			fclose(conf);
			return;
		}
	}
	free(mpqname);
	fclose(conf);
	return;	
}

DWORD __stdcall OnStormLoad(LPVOID param)
{
	char owd[1024];
	HMODULE hStorm = NULL;
	while(1) {
		hStorm = GetModuleHandle("storm.dll");
		if(hStorm != NULL) break;
		Sleep(1);
	}

	GetCurrentDirectory(1024,owd);
	SetCurrentDirectory(cwd);
	
	LoadMPQ(hStorm);

	SetCurrentDirectory(owd);
	return 0;
}


extern "C" BOOL __stdcall DllMain(HMODULE module, DWORD reason,LPVOID reserved)
{
	if(reason == DLL_PROCESS_ATTACH) {
		GetCurrentDirectory(1024,cwd);
		DisableThreadLibraryCalls(module);
		CloseHandle(CreateThread(NULL,32768,OnStormLoad,NULL,0,NULL));
	}
	return true;
}
