#include "menu.h"

int MenuItem::GetCheck() { return mChecked; }

void MenuItem::ClearCheck()
{
	mChecked = 0;
	Redraw();
}

void MenuItem::Redraw()
{
	MENUITEMINFO m;
	memset(&m,0,sizeof(MENUITEMINFO));
	m.cbSize = sizeof(MENUITEMINFO);
	m.fMask = MIIM_STATE;
	if(mChecked) m.fState = MFS_CHECKED;
	else m.fState = MFS_UNCHECKED;
	SetMenuItemInfo(mMenu,mID,false,&m);
	DrawMenuBar(mWindow);
}

MenuItem::MenuItem(HWND window, HMENU menu, int ID,char *text) : mWindow(window),mMenu(menu),mID(ID),mChecked(false)
{
	AppendMenu(mMenu,MF_STRING,mID,text);
	Redraw();
}

void MenuItem::Toggle()
{
	mChecked ^= 1;
	Redraw();
}

