/*
 * these natives by PipeDream, 2006
 * mostly STL wrappers
 */

/*
The following routines are all exported by japi.dll:

char* MemStrSearch(unsigned char *start, unsigned char *end, char *str);
bool MemPatternCompare(unsigned char *address, unsigned char *pattern, unsigned char *mask, unsigned long length);
unsigned char* MemPatternSearch(unsigned char *start, unsigned char *end, unsigned char *pattern, unsigned char *mask, unsigned long length);

PIMAGE_SECTION_HEADER GetImageSectionHeaders(HMODULE hModule, WORD *count);
PIMAGE_SECTION_HEADER GetImageSectionHeader(HMODULE hModule, unsigned char name[8]);

void	jAPI jBindNative(void *routine, char *name, char *prototype);
void	jAddNative(void *routine, char *name, char *prototype);
jString jAPI jStrMap(char *str);
char*	jAPI jStrGet(jString strid);
*/
// - Andy Scott aka xttocs


#include <windows.h>
#include <stdio.h>
#include <stdarg.h>
#include <vector>
#include <map>
#include <deque>
#include <time.h>
using namespace std;

#include "natives.h"

#define jNATIVE	__stdcall
#define jAPI	__fastcall

#define FloatAsInt(f) (*(long*)&f)
#define IntAsFloat(i) (*(float*)&i)

typedef long jString;
typedef long jInt;
typedef long jReal;

typedef void	(jAPI *jpAddNative)(void *routine, char *name, char *prototype);
/*typedef jString (jAPI *jpStrMap)	(char *str);
typedef char *	(jAPI *jpStrGet)	(jString strid);*/

/*extern jpAddNative	jAddNative;
extern jpStrMap		jStrMap;
extern jpStrGet		jStrGet;*/


vector<int> *jNATIVE ArrayAlloc(int len)
{
	return new vector<int>(len);
}

int jNATIVE ArraySet(vector<int> *array,int index,int val)
{
	(*array)[index]=val;
	return (*array)[index];
}

int jNATIVE ArrayGet(vector<int> *array, int index)
{
	return (*array)[index];
}

/*
int jNATIVE ArraySave(vector<int> *array, jString jname)
{
	int x=0;
	static char *name = NULL;	//User gets to use only one database
	if(name == NULL) name = jStrGet(jname);
	FILE *database = fopen("database","r+b");
	if(!database) {
		database = fopen("database","wb"); 	//create it
		if(!database)
		fwrite(&x,sizeof(int),1,database);
		fclose(database);
		database = fopen("database","r+b");
	}
	return 1;
}
*/
void jNATIVE ArrayFree(vector<int> *array)
{
	delete array;
}

deque<int> *DequeNew()
{
	return new deque<int>;
}

int jNATIVE DequePushFront(deque<int> *d,int x)
{
	d->push_front(x);
	return x;
}
int jNATIVE DequePushBack(deque<int> *d,int x)
{
	d->push_back(x);
	return x;
}
int jNATIVE DequeFront(deque<int> *d) { return d->front(); }
int jNATIVE DequeBack(deque<int> *d) { return d->back(); }
int jNATIVE DequePopFront(deque<int> *d)
{
	int x = d->front();
	d->pop_front();
	return x;
}
int jNATIVE DequePopBack(deque<int> *d)
{
	int x = d->back();
	d->pop_back();
	return x;
}

void jNATIVE DequeFree(deque<int> *d) { delete d; }

map<int,int> *MapNew()
{
	return new map<int,int>;
}
int jNATIVE MapSet(map<int,int> *m,int in,int out)
{
	(*m)[in] = out;
	return out;
}
int jNATIVE MapGet(map<int,int> *m,int in)
{
	return (*m)[in];
}
void jNATIVE MapFree(map<int,int> *m)
{
	delete m;
}


typedef struct {
	int car;
	int cdr;
} Pair;

Pair *jNATIVE cons(int x, int y)
{
	Pair *newpair = new Pair;
	newpair->car = x;
	newpair->cdr = y;
	return newpair;
}

int jNATIVE car(Pair *p)
{
	return p->car;
}
int jNATIVE cdr(Pair *p)
{
	return p->cdr;
}

void jNATIVE destroypair(Pair *p)
{
	delete p;
}

//typedef clock_t watch_t;
typedef __int64 watch_t;

watch_t *jNATIVE StopWatchCreate()
{
	watch_t *x = new watch_t;
	QueryPerformanceCounter((LARGE_INTEGER *)x);
	//*x = clock();
	return x;
}

//got to return int to make it go on eax instead of floating point stack
int jNATIVE StopWatchMark(watch_t *x)
{
	watch_t y,interval,freq;
	float f;
	QueryPerformanceCounter((LARGE_INTEGER *)&y);
	QueryPerformanceFrequency((LARGE_INTEGER *)&freq);
	//y = clock();
	interval = y - (*x);
	f = (float)interval/(float)freq;
//	f = (float)interval/(float)CLOCKS_PER_SEC;
	return *(int *)&f;
}

void jNATIVE StopWatchDestroy(watch_t *x)
{
	delete x;
}

int typecast(int x) { return x; }

typedef unsigned long int	mp_limb_t;

typedef struct
{
  int _mp_alloc;		/* Number of *limbs* allocated and pointed
				   to by the _mp_d field.  */
  int _mp_size;			/* abs(_mp_size) is the number of limbs the
				   last field points to.  If _mp_size is
				   negative this is a negative number.  */
  mp_limb_t *_mp_d;		/* Pointer to the limbs.  */
} __mpz_struct;
typedef __mpz_struct mpz_t[1];

#define dllconv __cdecl

typedef void dllconv (*pgmp_initint)(mpz_t);
typedef void dllconv (*pgmp_freeint)(mpz_t);
typedef void dllconv (*pgmp_setint)(mpz_t,int);
typedef int dllconv (*pgmp_getint)(mpz_t);
typedef void dllconv (*pgmp_addint)(mpz_t,mpz_t,mpz_t);
typedef void dllconv (*pgmp_subint)(mpz_t,mpz_t,mpz_t);
typedef void dllconv (*pgmp_mulint)(mpz_t,mpz_t,mpz_t);
typedef void dllconv (*pgmp_divint)(mpz_t q,mpz_t n, mpz_t d);
typedef void dllconv (*pgmp_modint)(mpz_t r,mpz_t n, mpz_t d);

pgmp_initint gmp_initint;
pgmp_freeint gmp_freeint;
pgmp_setint gmp_setint;
pgmp_getint gmp_getint;
pgmp_addint gmp_addint;
pgmp_subint gmp_subint;
pgmp_mulint gmp_mulint;
pgmp_divint gmp_divint;
pgmp_modint gmp_modint;

typedef __mpz_struct mpint;

mpint * jNATIVE mpz_new()
{
	mpint *x = new mpint[1];
	gmp_initint(x);
	return x;
}
void jNATIVE mpz_delete(mpint *z) { gmp_freeint(z);delete z; }
void jNATIVE mpz_set(mpint *z,int i) { gmp_setint(z,i); }
int jNATIVE mpz_get(mpint *z) { return gmp_getint(z); }
void jNATIVE mpz_add(mpint *a,mpint *b, mpint *c) { gmp_addint(a,b,c); }
void jNATIVE mpz_sub(mpint *a,mpint *b, mpint *c) { gmp_subint(a,b,c); }
void jNATIVE mpz_mul(mpint *a,mpint *b, mpint *c) { gmp_mulint(a,b,c); }
void jNATIVE mpz_div(mpint *a,mpint *b, mpint *c) { gmp_divint(a,b,c); }
void jNATIVE mpz_mod(mpint *a,mpint *b, mpint *c) { gmp_modint(a,b,c); }

void *getproc(HINSTANCE lib,char *fn)
{
	void *x = (void *)GetProcAddress(lib,fn);
	if(!x) {
		fprintf(stderr,"could not find %s",fn);
		exit(1);
	}
	return x;
}

void loadgmp()
{
	HINSTANCE gmp = LoadLibrary("gmp.dll");
	if(!gmp) {
		fprintf(stderr,"Could not find gmp.dll");
		//Put a useful error here......
	}

	gmp_initint = (pgmp_initint)getproc(gmp,"__gmpz_init");
	gmp_freeint = (pgmp_freeint)getproc(gmp,"__gmpz_clear");
	gmp_setint = (pgmp_setint)getproc(gmp,"__gmpz_set_si");
	gmp_getint = (pgmp_getint)getproc(gmp,"__gmpz_get_si");
	gmp_addint = (pgmp_addint)getproc(gmp,"__gmpz_add");
	gmp_subint = (pgmp_subint)getproc(gmp,"__gmpz_sub");
	gmp_mulint = (pgmp_mulint)getproc(gmp,"__gmpz_mul");
	gmp_divint = (pgmp_divint)getproc(gmp,"__gmpz_fdiv_q");
	gmp_modint = (pgmp_modint)getproc(gmp,"__gmpz_fdiv_r");

	jAddNative((void *)mpz_new,"MPZnew","()I");
	jAddNative((void *)mpz_delete,"MPZdelete","(I)V");
	jAddNative((void *)mpz_set,"MPZset","(II)V");
	jAddNative((void *)mpz_get,"MPZget","(I)I");
	jAddNative((void *)mpz_add,"MPZadd","(III)V");
	jAddNative((void *)mpz_sub,"MPZsub","(III)V");
	jAddNative((void *)mpz_mul,"MPZmul","(III)V");
	jAddNative((void *)mpz_div,"MPZdiv","(III)V");
	jAddNative((void *)mpz_mod,"MPZmod","(III)V");
}

//XTEA
//32 rounds recommended
void encipher(unsigned int num_rounds, unsigned long* v, unsigned long* k) {
    unsigned long v0=v[0], v1=v[1], i;
    unsigned long sum=0, delta=0x9E3779B9;
    for(i=0; i<num_rounds; i++) {
        v0 += ((v1 << 4 ^ v1 >> 5) + v1) ^ (sum + k[sum & 3]);
        sum += delta;
        v1 += ((v0 << 4 ^ v0 >> 5) + v0) ^ (sum + k[sum>>11 & 3]);
    }
    v[0]=v0; v[1]=v1;
}

void decipher(unsigned int num_rounds, unsigned long* v, unsigned long* k) {
    unsigned long v0=v[0], v1=v[1], i;
    unsigned long delta=0x9E3779B9, sum=delta*num_rounds;
    for(i=0; i<num_rounds; i++) {
        v1 -= ((v0 << 4 ^ v0 >> 5) + v0) ^ (sum + k[sum>>11 & 3]);
        sum -= delta;
        v0 -= ((v1 << 4 ^ v1 >> 5) + v1) ^ (sum + k[sum & 3]);
    }
    v[0]=v0; v[1]=v1;
}

void jNATIVE encipherwrap(unsigned int rounds, vector<int> *v, vector<int> *k)
{
	unsigned long sv[2] = { (*v)[0],(*v)[1] };
	unsigned long sk[4] = { (*k)[0],(*k)[1],(*k)[2],(*k)[3] };
	if(rounds > 256) rounds = 256;
	encipher(rounds,sv,sk);
	(*v)[0] = sv[0];(*v)[1]=sv[1];
}
void jNATIVE decipherwrap(unsigned int rounds, vector<int> *v, vector<int> *k)
{
	unsigned long sv[2] = { (*v)[0],(*v)[1] };
	unsigned long sk[4] = { (*k)[0],(*k)[1],(*k)[2],(*k)[3] };
	if(rounds > 256) rounds = 256;
	decipher(rounds,sv,sk);
	(*v)[0] = sv[0];(*v)[1]=sv[1];
}

typedef void			(__fastcall *JassProcBindNative)(void *routine, char *name, char *prototype);
typedef unsigned long	(__fastcall *JassProcStrMap)(char *str);
typedef char *			(__fastcall *JassProcStrGet)(unsigned long strid);

extern JassProcBindNative			JassBindNative;
extern JassProcStrMap				JassStrMap;
extern JassProcStrGet				JassStrGet;

/*int jNATIVE gethotkey(int x) {
	FILE *f = fopen("D:\\code\\wargame\\hotlog.txt","a");
	fprintf(f,"%d %s\n", x, JassStrGet(x));
	fclose(f);
	return 0;
}*/


FILE *debuglog;
int jNATIVE jDebugPrint(int x)
{
	fprintf(debuglog,"%s\n",JassStrGet(x));
	fflush(debuglog);
	return 0;
}

void InitNativePack(INITT t)
{
//	jAddNative((void *)gethotkey,"GetLocalizedHotkey","(S)I");

	jAddNative((void *)ArrayAlloc,"ArrayAlloc","(I)I");
	jAddNative((void *)ArraySet,"ArraySetI","(III)I");
	jAddNative((void *)ArrayGet,"ArrayGetI","(II)I");
	jAddNative((void *)ArrayFree,"ArrayFree","(I)V");

	jAddNative((void *)DequeNew,"DequeNew","()I");
	jAddNative((void *)DequePushFront,"DequePushFrontI","(II)I");
	jAddNative((void *)DequePushBack,"DequePushBackI","(II)I");
	jAddNative((void *)DequeFront,"DequeFrontI","(I)I");
	jAddNative((void *)DequeBack,"DequeBackI","(I)I");
	jAddNative((void *)DequePopFront,"DequePopFrontI","(I)I");
	jAddNative((void *)DequePopBack,"DequePopBackI","(I)I");
	jAddNative((void *)DequeFree,"DequeFree","(I)V");

	jAddNative((void *)MapNew,"MapNew","()I");
	jAddNative((void *)MapSet,"MapSetII","(III)I");
	jAddNative((void *)MapGet,"MapGetII","(II)I");
	jAddNative((void *)MapSet,"MapSetSI","(ISI)I");
	jAddNative((void *)MapGet,"MapGetSI","(IS)I");
	jAddNative((void *)MapFree,"MapFree","(I)V");

	jAddNative((void *)cons,"consII","(II)I");
	jAddNative((void *)car,"carI","(I)I");
	jAddNative((void *)cdr,"cdrI","(I)I");
	jAddNative((void *)destroypair,"destroypair","(I)V");

	jAddNative((void *)StopWatchCreate,"StopWatchCreate","()I");
	jAddNative((void *)StopWatchMark,"StopWatchMark","(I)R");
	jAddNative((void *)StopWatchDestroy,"StopWatchDestroy","(I)V");

	jAddNative((void *)typecast,"ItoR","(I)R");
	jAddNative((void *)typecast,"RtoI","(R)I");

	jAddNative((void *)encipherwrap,"Encrypt","(III)V");
	jAddNative((void *)encipherwrap,"Decrypt","(III)V");

	jAddNative((void *)jDebugPrint,"DebugPrint","(S)V");

	if(t == WAR3_INIT) {
		debuglog = fopen("debugprintlog.txt","w");
	}

//	loadgmp();
}
