#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include "natives.h"
#include "iat.h"

#include <map>

void WriteRelativeAddress(void *StartingAddress, void *TargetAddress)
{
	DWORD dwOldProtect = 0, dwOldProtect2 = 0;
	VirtualProtect(StartingAddress, 4, PAGE_WRITECOPY, &dwOldProtect);
	*(long*)StartingAddress = (long)PtrToUlong(TargetAddress) - (long)(PtrToUlong(StartingAddress) + 4);
	VirtualProtect(StartingAddress, 4, dwOldProtect, &dwOldProtect2);
}
#define PointerFromAddress(base, offset) ((unsigned char*)UlongToPtr(*(unsigned long *)((unsigned char *)base + offset)))
#define ExtractTransferAddressPtr(base, offset) (void *)((unsigned char *)base + *(long *)((unsigned char *)base + offset) + offset + 4)
#define ExtractTransferAddress(base, offset) PtrToUlong(ExtractTransferAddressPtr(base, offset))


FILE *fout; 
void msgout(char *msg) {
	fprintf(fout,"%s",msg);
	fflush(fout);
}

void DebugPrint(char *msg)
{
	DWORD dwWritten;
	msgout(msg);
	WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), msg, (DWORD)strlen(msg), &dwWritten, 0);
}

void DebugPrintLn(char *msg)
{
	DWORD dwWritten;
	msgout(msg);
	msgout("\n");
	WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), msg, (DWORD)strlen(msg), &dwWritten, 0);
	WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), "\n", 1, &dwWritten, 0);
}

void DebugPrintf(char *format, ... )
{
	char msg[500];
	va_list args;
	va_start(args, format);
	vsprintf(msg, format, args);
	DebugPrint(msg);
}

char *MemStrSearch(unsigned char *start, unsigned char *end, char *str)
{
	size_t size = strlen(str);
	for (unsigned char *i = start; i <= end; i++)
		if (memcmp(i, str, size) == 0)
			return (char*)i;
	return 0;
}

bool MemPatternCompare(unsigned char *address, unsigned char *pattern, unsigned char *mask, unsigned long length)
{
	for (unsigned long j = 0; j < length; j++)
		if ((address[j] & mask[j]) != pattern[j])
			return false;
	return true;
}

unsigned char *MemPatternSearch(unsigned char *start, unsigned char *end, unsigned char *pattern, unsigned char *mask, unsigned long length)
{
	for (unsigned char *i = start; i <= end; i++)
		if (MemPatternCompare(i, pattern, mask, length))
			return i;
	return 0;
}

PIMAGE_SECTION_HEADER GetImageSectionHeaders(HMODULE hModule, WORD *count)
{
	if (PIMAGE_DOS_HEADER(hModule)->e_magic != IMAGE_DOS_SIGNATURE)
		return 0;

	PIMAGE_NT_HEADERS pNTHeader = PIMAGE_NT_HEADERS((PBYTE)(hModule) + PIMAGE_DOS_HEADER(hModule)->e_lfanew);
	if (pNTHeader->Signature != IMAGE_NT_SIGNATURE)
		return 0;

	*count = pNTHeader->FileHeader.NumberOfSections;
	return PIMAGE_SECTION_HEADER(pNTHeader + 1);
}

PIMAGE_SECTION_HEADER GetImageSectionHeader(HMODULE hModule, char name[8])
{
	WORD count = 0;
	PIMAGE_SECTION_HEADER pSectionHeader = GetImageSectionHeaders(hModule, &count);

	for (WORD i = 0; i < count; i++)
		if (memcmp(pSectionHeader + i, name, 8) == 0) // Maybe this should be strcmp?
			return pSectionHeader + i;

	return 0;
}


//6F2483F0  /$ 55             PUSH EBP
#define FloatAsInt(f) (*(long*)&f)
#define IntAsFloat(i) (*(float*)&i)
#define UnknownData(x)		UnknownData2(x, __COUNTER__)
#define PaddingData(x)		UnknownData2(x, __COUNTER__)
#define UnknownData2(x, c)	UnknownData3(x, c)
#define UnknownData3(x, c)	unsigned char z_unknown_##c##_[x];

typedef struct
{
//	UnknownData(0x30);
	char UnknownData[0x30];
	unsigned long UnitId;
} *HW3UNIT, W3UNIT;


enum DEFENSE_TYPE
{
	DEFENSE_TYPE_UNKNOWN = 0,
	DEFENSE_TYPE_SMALL   = 0,
	DEFENSE_TYPE_MEDIUM,
	DEFENSE_TYPE_LARGE,
	DEFENSE_TYPE_FORT,
	DEFENSE_TYPE_NORMAL,
	DEFENSE_TYPE_HERO,
	DEFENSE_TYPE_DIVINE,
	DEFENSE_TYPE_NONE
};

//6F1BA391  |. 8BEC           MOV EBP,ESP

//6F1B21E2  |. E8 A9810000    CALL Game.6F1BA390



// Attack target flags
#define ATTACK_TARGET_GROUNDF		2
#define ATTACK_TARGET_AIRF			4
#define ATTACK_TARGET_STRUCTUREF	8
#define ATTACK_TARGET_WARDF			16
#define ATTACK_TARGET_ITEMF			32

typedef struct
{
//	UnknownData(0x14);
	char unk1[0x14];
	unsigned long UnitId;		// 0x14
	unsigned long BuildTime;	// 0x18
	unsigned long RepairTime;	// 0x1C
	unsigned long GoldCost;		// 0x20
	unsigned long LumberCost;	// 0x24
	unsigned long GoldRep;		// 0x28
	unsigned long LumberRep;	// 0x2C
	char unk2[0x68];
//	UnknownData(0x68);
	DEFENSE_TYPE  DefenseType;  // 0x98
	//unsigned long DefenseType;
	char unk3[0x04];
//	UnknownData(0x04)
	unsigned long AttackTargs1; // 0xA0
	unsigned long AttackTargs2; // 0xA4
	char unk4[0x40];
//	UnknownData(0x40);
	unsigned long AttackType1;	// 0xE8
	unsigned long AttackType2;  // 0xEC
	char unk5[0x04];
//	UnknownData(0x04);
	unsigned long WeaponType1;  // 0xF8
	unsigned long WeaponType2;  // 0xFC
	char unk6[0x100];
//	UnknownData(0x100);
} *HW3UNITINFO, W3UNITINFO;

struct jnNode
{
	void *routine;
	char *name;
	char *prototype;
	jnNode *next;
};


unsigned char JassBindNativeCallPattern[] = 
{
	0x68, 0x00, 0x00, 0x00, 0x00,
	0xBA, 0x00, 0x00, 0x00, 0x00,
	0xB9, 0x00, 0x00, 0x00, 0x00,
	0xE8
};

unsigned char JassBindNativeCallMask[] = 
{
	0xFF, 0x00, 0x00, 0x00, 0x00,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0x00, 0x00, 0x00, 0x00,
	0xFF
};

unsigned char JassStrMapCallPattern[] =
{
	0xE8, 0x00, 0x00, 0x00, 0x00,
	0x8B, 0xE5,
	0x5D,
	0xC3
};

unsigned char JassStrMapCallMask[] = 
{
	0xFF, 0x00, 0x00, 0x00, 0x00,
	0xFF, 0xFF,
	0xFF, 
	0xFF
};

unsigned char JassStrGetCallPattern[] = 
{
	0x55,
	0x8B, 0xEC,
	0x8B, 0x4D, 0x08,
	0xE8
};

unsigned char JassStrGetCallMask[] = 
{
	0xFF,
	0xFF, 0xFF, 
	0xFF, 0xFF, 0xFF,
	0xFF
};

/*
6F1AB0A4   E8 977EFEFF      CALL Game.6F192F40
6F1AB0A9   85C0             TEST EAX,EAX
6F1AB0AB   74 1B            JE SHORT Game.6F1AB0C8
6F1AB0AD   8BC8             MOV ECX,EAX
6F1AB0AF   E8 FEC74800      CALL <JMP.&War3.#754_NK>
6F1AB0B4   8BD0             MOV EDX,EAX
6F1AB0B6   8BCE             MOV ECX,ESI
6F1AB0B8   E8 A36EE5A0      CALL revoluti.10001F60
*/
unsigned char SLKProcessUnitCallPattern[] = 
{
	0xE8, 0x00, 0x00, 0x00, 0x00,
	0x85, 0xC0,
	0x74, 0x00,
	0x8B, 0xC8,
	0xE8, 0x00, 0x00, 0x00, 0x00,
	0x8B, 0xD0,
	0x8B, 0xCE,
	0xE8 /* SLPProcessUnit @ 21! */
};

unsigned char SLKProcessUnitCallMask[] =
{
	0xFF, 0x00, 0x00, 0x00, 0x00,
	0xFF, 0xFF,
	0xFF, 0x00,
	0xFF, 0xFF,
	0xFF, 0x00, 0x00, 0x00, 0x00,
	0xFF, 0xFF,
	0xFF, 0xFF,
	0xFF
};

/*
6F2C1480   55               PUSH EBP
6F2C1481   8BEC             MOV EBP,ESP
6F2C1483   83EC 08          SUB ESP,8
6F2C1486   8B0D BC22876F    MOV ECX,DWORD PTR DS:[6F8722BC]
6F2C148C   53               PUSH EBX
6F2C148D   33DB             XOR EBX,EBX
6F2C148F   57               PUSH EDI
6F2C1490   895D FC          MOV DWORD PTR SS:[EBP-4],EBX
6F2C1493   E8 389EFDFF      CALL game.6F29B2D0
6F2C1498   8B4D 08          MOV ECX,DWORD PTR SS:[EBP+8]
6F2C149B   85C9             TEST ECX,ECX
6F2C149D   0F84 9D000000    JE game.6F2C1540
6F2C14A3   56               PUSH ESI
6F2C14A4   51               PUSH ECX
6F2C14A5   8BC8             MOV ECX,EAX
6F2C14A7   E8 84600600      CALL game.6F327530
*/

unsigned char UnitHandlePattern[] = 
{
	0x55,
	0x8B, 0xEC,
	0x83, 0xEC, 0x00,
	0x8B, 0x0D, /**/ 0x00, 0x00, 0x00, 0x00, /* GameObjectPointer @ 8 */
	0x53,
	0x33, 0xDB,
	0x57,
	0x89, 0x5D, 0x00,
	0xE8, /**/ 0x00, 0x00, 0x00, 0x00, /* GameObjectMethodA @ 20 */
	0x8B, 0x4D, 0x08,
	0x85, 0xC9,
	0x0F, 0x84, 0x00, 0x00, 0x00, 0x00,
	0x56,
	0x51,
	0x8B, 0xC8,
	0xE8 /* JassObjectMethodA @ 40 */
};

unsigned char UnitHandleMask[] = 
{
	0xFF,
	0xFF, 0xFF,
	0xFF, 0xFF, 0x00,
	0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
	0xFF,
	0xFF, 0xFF,
	0xFF,
	0xFF, 0xFF, 0x00,
	0xFF, 0x00, 0x00, 0x00, 0x00,
	0xFF, 0xFF, 0xFF,
	0xFF, 0xFF,
	0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
	0xFF,
	0xFF,
	0xFF, 0xFF,
	0xFF
};

///////////////////////////////////////////////////

// Game internals... routines and some object pointers

typedef void			(__fastcall *JassProcBindNative)(void *routine, char *name, char *prototype);
typedef unsigned long	(__fastcall *JassProcStrMap)(char *str);
typedef char *			(__fastcall *JassProcStrGet)(unsigned long strid);

JassProcBindNative			JassBindNative;
JassProcStrMap				JassStrMap;
JassProcStrGet				JassStrGet;

unsigned long			SLKProcessUnit;		// 1.20.2.6065: 0x6F1A55C0
unsigned long			GameObjectPointer;	// 1.20.2.6065: 0x6F8722BC
unsigned long			GameObjectMethodA;	// 1.20.2.6065: 0x6F29B2D0
unsigned long			JassObjectMethodA;	// 1.20.2.6065: 0x6F327530

// Some stuff we use

jnNode jnBaseNode;

std::map<unsigned long, W3UNITINFO *> UnitInfoMap;

HMODULE hJassModule;

// Some Jass natives I want to call...

typedef unsigned long   (__stdcall  *jpDisplayTextToPlayer)(unsigned long toPlayer, float *x, float *y, unsigned long message, char *);
typedef unsigned long   (__stdcall  *jpPlayer)(unsigned long number, char *);
typedef unsigned long   (__stdcall  *jpGetLocalPlayer)(char *);

jpDisplayTextToPlayer	jDisplayTextToPlayer;
jpPlayer				jPlayer;
jpGetLocalPlayer		jGetLocalPlayer;

///////////////////////////////////////////////////

void *FindBlizzardJassNative(char *name)
{
	unsigned char JassBindNativeCallPattern[] = 
	{
		0x68, 0x00, 0x00, 0x00, 0x00,
		0xBA, 0x00, 0x00, 0x00, 0x00,
		0xB9, 0x00, 0x00, 0x00, 0x00,
		0xE8
	};

	unsigned char JassBindNativeCallMask[] = 
	{
		0xFF, 0x00, 0x00, 0x00, 0x00,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0x00, 0x00, 0x00, 0x00,
		0xFF
	};

	HMODULE hModule = NULL;
	PIMAGE_SECTION_HEADER Section = GetImageSectionHeader(hJassModule, ".text\0\0\0");
	unsigned char *low	= (unsigned char*)hJassModule + Section->VirtualAddress;
	unsigned char *high	= low + Section->Misc.VirtualSize;

	char *nameInModule;
	if ((nameInModule = MemStrSearch(low, high, name)) == 0)
		return 0;

	Section = GetImageSectionHeader(hModule, ".data\0\0\0");
	low		= (unsigned char*)hModule + Section->VirtualAddress;
	high	= low + Section->Misc.VirtualSize;

	unsigned char *address;

	*(unsigned long*)(JassBindNativeCallPattern + 6) = PtrToUlong(nameInModule);
	if ((address = MemPatternSearch(low, high, JassBindNativeCallPattern, JassBindNativeCallMask, 16)) == 0)
		return false;
	
	return PointerFromAddress(address, 11);
}

///////////////////////////////////////////////////

extern "C" void JassInitializationHook_2()
{
	jnNode *n = &jnBaseNode;
	DebugPrintf("Binding Natives:\n");
	while (n = n->next)
	{
		JassBindNative(n->routine, n->name, n->prototype);
		DebugPrintf("0x%x %s%s\n", PtrToUlong(n->routine), n->name, n->prototype);
	}
}

extern "C" void JassInitializationHook();

#ifdef DEBUG_CONSOLE
std::map<unsigned long, W3UNITINFO *> UnitInfoMapCompare2;
std::map<unsigned long, W3UNITINFO *> UnitInfoMapCompare1;
#endif

extern "C" void __cdecl SLKProcessingHook_2(W3UNITINFO *UnitInfo)
{

#ifdef DEBUG_CONSOLE
	if (UnitInfoMapCompare2[UnitInfo->UnitId])
		delete UnitInfoMapCompare2[UnitInfo->UnitId];
	if (UnitInfoMapCompare1[UnitInfo->UnitId])
		UnitInfoMapCompare2[UnitInfo->UnitId] = UnitInfoMapCompare1[UnitInfo->UnitId];

	W3UNITINFO *UnitInfoCompare1 = new W3UNITINFO;
	memcpy(UnitInfoCompare1, UnitInfo, sizeof(W3UNITINFO));
	UnitInfoMapCompare1[UnitInfo->UnitId] = UnitInfoCompare1;
#endif

	UnitInfoMap[UnitInfo->UnitId] = UnitInfo;
}

extern "C" void SLKProcessingHook();

///////////////////////////////////////////////////

// Functions called by the natives and the init routines

void jAddNative(void *routine, char *name, char *prototype)
{
	static jnNode *top	= &jnBaseNode;
	jnNode *n			= new jnNode;
	n->routine			= routine;
	n->name				= name;
	n->prototype		= prototype;
	n->next				= 0;
	top->next			= n;
	top					= n;
}

extern "C" W3UNIT *__stdcall UnitFromJassHandle(unsigned long Handle); // I think this works for any handle lookup...

// >>>>>>>>>>> Alas, our natives >>>>>>>>>

#define jNATIVE	__stdcall

typedef struct
{
	//UnknownData(0x18);
	char unk1[0x18];
	char *name;			// 0x18
	void *routine;
	char unk2[0x4];
	//UnknownData(0x4);	// 0x1C
	char *prototype;	// 0x24
} JASSNATIVENODE;

typedef JASSNATIVENODE *(__fastcall  *jpFindNative)(char *native);
jpFindNative jFindNative = (jpFindNative)0x6F69E000; // 1.20d

unsigned long _byteswap_ulong(unsigned long x)
{
	char *s = (char *)&x;
	char t;
	t = s[0];
	s[0] = s[3];
	s[3] = t;
	t = s[1];
	s[1] = s[2];
	s[2] = t;
	return x;
}

void jNATIVE jDumpUnitInfo(unsigned long whichUnit, char *n)
{
	
	//JASSNATIVENODE *native = jFindNative("Sin");
	//DebugPrintf("0x%x %s%s\n", native->routine, native->name, native->prototype);

	
	static char *targets[] = {"ground", "air", "structure", "ward", "item"};

	W3UNIT *Unit = UnitFromJassHandle(whichUnit);
	W3UNITINFO *UnitInfo = UnitInfoMap[Unit->UnitId];
	unsigned long UnitIdSwapped = _byteswap_ulong(UnitInfo->UnitId);
	DebugPrintf("%s called on %d:0x%X)\n", n, whichUnit, Unit);
	DebugPrintf("\tUnit info located at 0x%X\n", UnitInfo);
	DebugPrintf("\tUnitId\t\t%.4s\n", &UnitIdSwapped);
	DebugPrintf("\tBuildTime\t%d\n", UnitInfo->BuildTime);
	DebugPrintf("\tRepairTime\t%d\n", UnitInfo->RepairTime);
	DebugPrintf("\tGoldCost\t%d\n", UnitInfo->GoldCost);
	DebugPrintf("\tLumberCost\t%d\n", UnitInfo->LumberCost);
	DebugPrintf("\tGoldRep\t\t%d\n", UnitInfo->GoldRep);
	DebugPrintf("\tLumberRep\t%d\n", UnitInfo->LumberRep);
	DebugPrintf("\tDefenseType\t%d\n", UnitInfo->DefenseType);
	DebugPrintf("\tAttackTargs1\t");
	for (unsigned char i = 1; i <= 5; i++)
		if (UnitInfo->AttackTargs1 & (2 << i))
			DebugPrintf("%s ", targets[i - 1]);
	DebugPrintf("\n");
	DebugPrintf("\tAttackType1\t%d\n", UnitInfo->AttackType1);
	DebugPrintf("\tWeaponType1\t%d\n", UnitInfo->WeaponType1);
	DebugPrintf("\tAttackType2\t%d\n", UnitInfo->AttackType2);
	DebugPrintf("\tWeaponType2\t%d\n", UnitInfo->WeaponType2);
	DebugPrintf("\tAttackTargs2\t");
	for (unsigned char i = 1; i <= 5; i++)
		if (UnitInfo->AttackTargs2 & (2 << i))
			DebugPrintf("%s ", targets[i - 1]);
	DebugPrintf("\n");

#ifdef DEBUG_CONSOLE
	unsigned char *previous = (unsigned char*)UnitInfoMapCompare2[Unit->UnitId];
	unsigned char *current  = (unsigned char*)UnitInfoMapCompare1[Unit->UnitId];
	if (previous && current)
		for (unsigned long i = 0; i < sizeof(W3UNITINFO); i++)
			if (previous[i] != current[i])
				DebugPrintf("0x%X: %d -> %d\n", i, previous[i], current[i]);
#endif
	

}

long jNATIVE GetUnitDefenseType(unsigned long whichUnit, char *n)
{
	W3UNIT *Unit = UnitFromJassHandle(whichUnit);
	if (!Unit)
		return -1;
	W3UNITINFO *UnitInfo = UnitInfoMap[Unit->UnitId];
	if (!UnitInfo)
		return -1;
	return  UnitInfo->DefenseType;
}

long jNATIVE GetDefenseType(unsigned long UnitId, char *n)
{
	W3UNITINFO *UnitInfo = UnitInfoMap[UnitId];
	if (!UnitInfo)
		return -1;
	return  UnitInfo->DefenseType;
}

long jNATIVE GetUnitAttackType1(unsigned long whichUnit, char *n)
{
	W3UNIT *Unit = UnitFromJassHandle(whichUnit);
	if (!Unit)
		return -1;
	W3UNITINFO *UnitInfo = UnitInfoMap[Unit->UnitId];
	if (!UnitInfo)
		return -1;
	return  UnitInfo->AttackType1;
}

long jNATIVE GetAttackType1(unsigned long UnitId, char *n)
{
	W3UNITINFO *UnitInfo = UnitInfoMap[UnitId];
	if (!UnitInfo)
		return -1;
	return  UnitInfo->AttackType1;
}


long jNATIVE GetUnitAttackType2(unsigned long whichUnit, char *n)
{
	W3UNIT *Unit = UnitFromJassHandle(whichUnit);
	if (!Unit)
		return -1;
	W3UNITINFO *UnitInfo = UnitInfoMap[Unit->UnitId];
	if (!UnitInfo)
		return -1;
	return  UnitInfo->AttackType2;
}

long jNATIVE GetAttackType2(unsigned long UnitId, char *n)
{
	W3UNITINFO *UnitInfo = UnitInfoMap[UnitId];
	if (!UnitInfo)
		return -1;
	return  UnitInfo->AttackType2;
}

long jNATIVE GetUnitWeaponType1(unsigned long whichUnit, char *n)
{
	W3UNIT *Unit = UnitFromJassHandle(whichUnit);
	if (!Unit)
		return -1;
	W3UNITINFO *UnitInfo = UnitInfoMap[Unit->UnitId];
	if (!UnitInfo)
		return -1;
	return  UnitInfo->WeaponType1;
}

long jNATIVE GetWeaponType1(unsigned long UnitId, char *n)
{
	W3UNITINFO *UnitInfo = UnitInfoMap[UnitId];
	if (!UnitInfo)
		return -1;
	return  UnitInfo->WeaponType1;
}

long jNATIVE GetUnitWeaponType2(unsigned long whichUnit, char *n)
{
	W3UNIT *Unit = UnitFromJassHandle(whichUnit);
	if (!Unit)
		return -1;
	W3UNITINFO *UnitInfo = UnitInfoMap[Unit->UnitId];
	if (!UnitInfo)
		return -1;
	return  UnitInfo->WeaponType2;
}

long jNATIVE GetWeaponType2(unsigned long UnitId, char *n)
{
	W3UNITINFO *UnitInfo = UnitInfoMap[UnitId];
	if (!UnitInfo)
		return -1;
	return  UnitInfo->WeaponType2;
}

// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

///////////////////////////////////////////////////

void InitNatives()
{
	jAddNative((void *)GetUnitDefenseType, "xGetUnitDefenseType", "(Hunit;)I");
	jAddNative((void *)GetDefenseType, "xGetDefenseType", "(I)I");
	jAddNative((void *)GetUnitAttackType1, "xGetUnitAttackType1", "(Hunit;)I");
	jAddNative((void *)GetAttackType1, "xGetAttackType1", "(I)I");
	jAddNative((void *)GetUnitAttackType2, "xGetUnitAttackType2", "(Hunit;)I");
	jAddNative((void *)GetAttackType2, "xGetAttackType2", "(I)I");
	jAddNative((void *)GetUnitWeaponType1, "xGetUnitWeaponType1", "(Hunit;)I");
	jAddNative((void *)GetWeaponType1, "xGetWeaponType1", "(I)I");
	jAddNative((void *)GetUnitWeaponType2, "xGetUnitWeaponType2", "(Hunit;)I");
	jAddNative((void *)GetWeaponType2, "xGetWeaponType2", "(I)I");
	jAddNative((void *)jDumpUnitInfo, "DumpUnitInfo", "(Hunit;)V");

}

bool InitNativesWar3(HMODULE hModule)
{
	hJassModule = hModule;

	DebugPrintf("Searching for addresses.. ");

	PIMAGE_SECTION_HEADER SectionData = GetImageSectionHeader(hModule, ".data\0\0\0");
	PIMAGE_SECTION_HEADER SectionText = GetImageSectionHeader(hModule, ".text\0\0\0");
	unsigned char *low, *high;
	low		= (unsigned char*)hModule + SectionData->VirtualAddress;
	high	= low + SectionData->Misc.VirtualSize;

	char *StringI2S, *StringStringLength;
	if ((StringI2S = MemStrSearch(low, high, "I2S")) == 0)
		return false;
	if ((StringStringLength = MemStrSearch(low, high, "StringLength")) == 0)
		return false;

	low		= (unsigned char*)hModule + SectionText->VirtualAddress;
	high	= low + SectionText->Misc.VirtualSize;

	unsigned char *address, *address2;

	*(unsigned long*)(JassBindNativeCallPattern + 6) = PtrToUlong(StringI2S);
	if ((address = MemPatternSearch(low, high, JassBindNativeCallPattern, JassBindNativeCallMask, 16)) == 0)
		return false;
	JassBindNative = (JassProcBindNative)ExtractTransferAddressPtr(address, 16);

	if ((address2 = MemPatternSearch(PointerFromAddress(address, 11), high, JassStrMapCallPattern, JassStrMapCallMask, 9)) == 0)
		return false;
	JassStrMap = (JassProcStrMap)ExtractTransferAddressPtr(address2, 1);


	*(unsigned long*)(JassBindNativeCallPattern + 6) = PtrToUlong(StringStringLength);
	if ((address = MemPatternSearch(low, high, JassBindNativeCallPattern, JassBindNativeCallMask, 16)) == 0)
		return false;
	if ((address2 = MemPatternSearch(PointerFromAddress(address, 11), high, JassStrGetCallPattern, JassStrGetCallMask, 7)) == 0)
		return false;
	JassStrGet = (JassProcStrGet)ExtractTransferAddressPtr(address2, 7);

	WriteRelativeAddress(address+16, (void *)JassInitializationHook);

	if ((address = MemPatternSearch(low, high, SLKProcessUnitCallPattern, SLKProcessUnitCallMask, 21)) == 0)
		return false;
	SLKProcessUnit = ExtractTransferAddress(address, 21);
	WriteRelativeAddress(address + 21, (void *)SLKProcessingHook);

	if ((address = MemPatternSearch(low, high,UnitHandlePattern, UnitHandleMask, 40)) == 0)
		return false;

	GameObjectPointer = *(unsigned long*)(address + 8);
	GameObjectMethodA = ExtractTransferAddress(address, 20);
	JassObjectMethodA = ExtractTransferAddress(address, 40);

	DebugPrintf(" found:\n");
	DebugPrintf("0x%X JassBindNative\n",		PtrToUlong(JassBindNative));
	DebugPrintf("0x%X JassStrMap\n",		PtrToUlong(JassStrMap));
	DebugPrintf("0x%X JassStrGet\n",		PtrToUlong(JassStrGet));
	DebugPrintf("0x%X SLKProcessUnit\n",	SLKProcessUnit);
	DebugPrintf("0x%X GameObjectPointer\n", GameObjectPointer);
	DebugPrintf("0x%X GameObjectMethodA\n", GameObjectMethodA);
	DebugPrintf("0x%X JassObjectMethodA\n", JassObjectMethodA);

	InitNatives();
	InitNativePack(WAR3_INIT);

	return true;
}

bool InitNativesWorldEdit(HMODULE hModule)
{
	hJassModule = hModule;

	PIMAGE_SECTION_HEADER SectionData = GetImageSectionHeader(hModule, ".data\0\0\0");
	PIMAGE_SECTION_HEADER SectionText = GetImageSectionHeader(hModule, ".text\0\0\0");
	unsigned char *low, *high;
	low		= (unsigned char*)hModule + SectionData->VirtualAddress;
	high	= low + SectionData->Misc.VirtualSize;

	char *StringI2S;
	if ((StringI2S = MemStrSearch(low, high, "I2S")) == 0)
		return false;

	low		= (unsigned char*)hModule + SectionText->VirtualAddress;
	high	= low + SectionText->Misc.VirtualSize;

	unsigned char *address; 

	*(unsigned long*)(JassBindNativeCallPattern + 6) = PtrToUlong(StringI2S);
	if ((address = MemPatternSearch(low, high, JassBindNativeCallPattern, JassBindNativeCallMask, 16)) == 0)
		return false;
	JassBindNative = (JassProcBindNative)ExtractTransferAddressPtr(address, 16);

	WriteRelativeAddress(address + 16, (void *)JassInitializationHook);

	DebugPrintf("JassBindNative found at 0x%X\n", PtrToUlong(JassBindNative));

	InitNatives();
	InitNativePack(WE_INIT);

	return true;
}

HMODULE __stdcall LoadLibraryAWrap(char *libname)
{
//	DebugPrintf("Hit LoadLibraryA\n");
	HMODULE lib = LoadLibraryA(libname);
	DebugPrintf("loading %s\n",libname);
	if(strcmpi("game.dll",libname)==0) {
		DebugPrintf("game.dll loaded..injecting natives\n");

		InitNativesWar3(GetModuleHandle("game.dll"));
	}
	return lib;
}


extern "C" BOOL __stdcall DllMain(HINSTANCE module,DWORD reason, LPVOID reserved)
{
	if (reason == DLL_PROCESS_ATTACH) {
		DisableThreadLibraryCalls(module);
		
		fout = fopen("japilog.txt","w");
		DebugPrintf("jAPI.dll loaded...hijacking IAT\n");

		try {
			HMODULE main = GetModuleHandle(0);
			char buf[1024];
			GetModuleFileName(main,buf,1024);
			DebugPrintf("Executable name: %s\n",buf);

			
			if(strstr(buf,"worldedit.exe") != NULL) {
				DebugPrintf("Detected worldedit.exe\n");
				DebugPrintf("game.dll: %x\n",GetModuleHandle(0));
				InitNativesWorldEdit(GetModuleHandle(0));
				fclose(fout);
			} else {
				DebugPrintf("Detected war3.exe\n");
				CIAT iat;
				iat.SetParentModule(GetModuleHandle(0));
				if(!iat.LocateForModule("kernel32.dll"))
					throw("Could not find kernel32.dll");
				if(!iat.RedirectImport("LoadLibraryA",(void *)LoadLibraryAWrap))
					throw("Could not redirect LoadLibraryA");
				DebugPrintf("Redirected LoadLibraryA\n");
			}
		} catch(const char *s) {
			DebugPrintf("Error: %s\n",s);
			char buf[1024];
			sprintf(buf,"Error: %s\n",s);
			MessageBox(NULL,buf,"jAPI.dll",MB_ICONERROR);
			return false;
		}
	}
	return true;
}
