#include <windows.h>
#include <stdio.h>
#include <stdarg.h>

#include "section.h"
#include "nreplace.h"

JassProcStrGet JassStrGet = NULL;
JassProcStrMap JassStrMap = NULL;

FILE *fout;
void dprintf(char *format,...)
{
	va_list args;
	va_start(args,format);
	vfprintf(fout,format,args);
	fflush(fout);
}

void patchbytes(void *dest, void *src, int len)
{
	DWORD old;
	DWORD old2;

	if(!VirtualProtect(dest,len,PAGE_READWRITE,&old)) throw((char *)"couldn't set PAGE_READWRITE on page");
	memmove(dest,src,len);
	if(!VirtualProtect(dest,len,old,&old2)) throw((char *)"couldn't restore permissions on page");
}

int __stdcall jGetHotkey(int x)
{
	int v;
	char *msg = JassStrGet(x);
	if(msg == NULL) return 0;
	dprintf("jGetHotkey msg: %s\n",msg);
	if(msg[0] == 'S') {	//save
		FILE *out = fopen("notdcode.txt","w");
		if(out == NULL) return 0;
		fprintf(out,"%s\n",msg+1);
		fclose(out);
		return 1;
	}else if(msg[0] == 'L') { //load
		FILE *in = fopen("notdcode.txt","r");
		if(in == NULL) return 0;
		//char buf[1024];
		fread(msg,12,1,in);
		msg[12] = '\0';
		fclose(in);
		//dprintf("pre strmap: %s\n",buf);
		v = JassStrMap(msg);
		//dprintf("post strmap\n");
		return v;
	}
	return 0;
}
//Indirection for jmp saves us from having to deal with stdcall decoration
//also deals with relative/absolute addressing
int pjGetHotkey = (int)jGetHotkey;
extern "C" void HotkeyPatch();
extern "C" void HotkeyPatchEnd();

void InstallHotkeyHack(Section &code)
{
	try {
		int HotkeyPatchsize = (int)HotkeyPatchEnd-(int)HotkeyPatch;
		unsigned char *target = code.Search(GetLocalizedHotkeyPattern,GetLocalizedHotkeyMask,sizeof(GetLocalizedHotkeyPattern));
		if(!target) throw((char *)"Hotkey signature not found");
		dprintf("Hotkey signature found at: %x\n",target);
		patchbytes((void *)target,(void *)HotkeyPatch,HotkeyPatchsize);
	} catch(const char *s) {
		dprintf("InstallHotkeyHack error: %s\n",s);
	}
}

void RetrieveWarFuncs(Section &code)
{
	try {
		//unsigned char *address = code.Search(JassStrGetCallPattern,JassStrGetCallMask,sizeof(JassStrGetCallPattern));
		unsigned char *address = (unsigned char *)0x6F2AD560;
		if(!address) throw((char *)"JassStrGet signature not found");
		dprintf("JassStrGet signature found at: %x\n",address);
		JassStrGet = (JassProcStrGet)address;

		address = (unsigned char *)GetProcAddress(GetModuleHandle("war3.exe"),(char *)411);
//		address = code.Search(JassStrMapCallPattern,JassStrMapCallMask,sizeof(JassStrMapCallPattern));
		if(!address) throw((char *)"JassStrMap not found");
		dprintf("JassStrMap found at: %x\n",address);
		JassStrMap = (JassProcStrMap)address;
	} catch(const char *s) {
		dprintf("RetrieveWarFuncs: error: %s\n",s);
	}
}

DWORD __stdcall OnGameLoad(LPVOID param)
{
	HMODULE hGame = NULL;
	while(1) {
		hGame = GetModuleHandle("game.dll");
		if(hGame != NULL) break;
		Sleep(1);
	}

	Section gamecode(hGame,".text\0\0\0");
	InstallHotkeyHack(gamecode);
	RetrieveWarFuncs(gamecode);

	return 0;
}

extern "C" BOOL __stdcall DllMain(HMODULE module, DWORD reason, LPVOID reserved)
{
	if(reason == DLL_PROCESS_ATTACH) {
		DisableThreadLibraryCalls(module);
		fout = fopen("nreplace.txt","w");
		CloseHandle(CreateThread(NULL,32768,OnGameLoad,NULL,0,NULL));
	}
	return true;
}
