#include <stdio.h>
#include <stdlib.h>

#include "parseconf.h"
#include "libbs.h"

#define BUFSIZE 1024
ParseConf::ParseConf(char *filename)
{
	FILE *f = fopen(filename,"r");
	dprintf("war3err.conf not found\n");
	if(f == NULL) return;
	char varname[BUFSIZE],value[BUFSIZE];
	dprintf("Loading war3err.conf:\n");
	while(fscanf(f,"%s = %s\n",varname,value)==2) {
		dprintf("  %s = %s\n",varname,value);
		m_var[strdup(varname)] = strdup(value);
	}
	fclose(f);
}

char *ParseConf::GetVar(char *s)
{
	std::map<char *, char *, ltstr>::iterator iter;
	iter = m_var.find(s);
	if(iter == m_var.end()) {
		return NULL;
	}
	return (*iter).second;
}

bool ParseConf::VarOn(char *key)
{
	char *value = GetVar(key);
	if(value == NULL) return false;
	if(strcmpi("on",value)==0) return true;
	if(strcmpi("true",value)==0) return true;
	return false;
}
