//thanks to Andy Scott aka xttocs
#include "section.h"

PIMAGE_SECTION_HEADER GetImageSectionHeaders(HMODULE hModule, WORD *count)
{
	if (PIMAGE_DOS_HEADER(hModule)->e_magic != IMAGE_DOS_SIGNATURE)
		return 0;

	PIMAGE_NT_HEADERS pNTHeader = PIMAGE_NT_HEADERS((PBYTE)(hModule) + PIMAGE_DOS_HEADER(hModule)->e_lfanew);
	if (pNTHeader->Signature != IMAGE_NT_SIGNATURE)
		return 0;

	*count = pNTHeader->FileHeader.NumberOfSections;
	return PIMAGE_SECTION_HEADER(pNTHeader + 1);
}

//NULL mask means match all bytes
//Give me some algebraic datatypes for chrissakes
bool MemPatternCompare(unsigned char *address, unsigned char *pattern, unsigned char *mask, unsigned long length)
{
	unsigned char bitmask;
	for (unsigned long j = 0; j < length; j++) {
		if(mask == NULL) bitmask = 0xFF;
		else bitmask = mask[j];
		if ((address[j] & bitmask) != pattern[j])
			return false;
	}
	return true;
}

unsigned char *MemPatternSearch(unsigned char *start, unsigned char *end, unsigned char *pattern, unsigned char *mask, unsigned long length)
{
	for (unsigned char *i = start; i <= end; i++)
		if (MemPatternCompare(i, pattern, mask, length))
			return i;
	return 0;
}


PIMAGE_SECTION_HEADER GetImageSectionHeader(HMODULE hModule, char name[8])
{
	WORD count = 0;
	PIMAGE_SECTION_HEADER pSectionHeader = GetImageSectionHeaders(hModule, &count);

	for (WORD i = 0; i < count; i++)
		if (memcmp(pSectionHeader + i, name, 8) == 0) // Maybe this should be strcmp?
			return pSectionHeader + i;

	return 0;
}

Section::Section(HMODULE module, char *name) : mName(name),mModule(module)
{
	PIMAGE_SECTION_HEADER section = GetImageSectionHeader(mModule,mName);
	mLow = (unsigned char*)mModule + section->VirtualAddress;
	mHigh = mLow + section->Misc.VirtualSize;
}

unsigned char *Section::Search(unsigned char *pattern, unsigned char *mask, int len)
{
	return MemPatternSearch(mLow,mHigh,pattern,mask,len);
}
