[bits 32]

global _LocationHook
global _LocationPatch
global _LocationPatchEnd

global _RegWaitHook
global _RegWaitPatch
global _RegWaitPatchEnd

global _OpHook
global _OpPatch
global _OpPatchEnd

global _OpLimitHook
global _OpLimitPatch
global _OpLimitPatchEnd

global _DivZeroHook
global _DivZeroPatch
global _DivZeroPatchEnd

global _VarUseHook
global _VarUsePatch
global _VarUsePatchEnd

global _PausePatch
global _PausePatchEnd


extern _LocationHandler
extern _RegWaitHandler
extern _OpHandler
extern _CountHandler
extern _DivZeroHandler
extern _VarUseHandler


section .data
pLocationHook	dd	_LocationHook
pRegWaitHook	dd	_RegWaitHook
pOpHook		dd	_OpHook
pOpLimitHook	dd	_OpLimitHook	;;indirect fixed address for jump target
pDivZeroHook	dd	_DivZeroHook	
pVarUseHook	dd	_VarUseHook

section .text
_LocationHook:
	push esi
	push esi
	call _LocationHandler
	pop esi
	pop esi

	;overwritten code
	mov eax,esi
	pop esi
	mov esp,ebp
	pop ebp

	ret
align 16
_LocationPatch:
	jmp [pLocationHook]
_LocationPatchEnd:
align 16


_RegWaitHook:
	call _RegWaitHandler	;Restores RegisterNatives to original state
	sub dword [esp],6	;shift return address to start of RegisterNatives
	ret
align 16
_RegWaitPatch:
	call [pRegWaitHook]
_RegWaitPatchEnd:
align 16

_OpHook:
	mov edi,[esi+0x20]
	lea ecx,[edi+4]
	push ecx
	push esi
	push edi
	call _OpHandler
	pop edi
	pop esi
	pop ecx
	ret

align 16
_OpPatch:
	call [pOpHook]
_OpPatchEnd:
align 16

_OpLimitHook:
    mov ecx,[esi+0x44]
    inc eax

    push esi
    push edi
    push eax
    push ecx
    call _CountHandler
    pop ecx
    pop eax
    pop edi
    pop esi

    cmp eax,ecx
    ret
    
align 16
    
_OpLimitPatch:
	call [pOpLimitHook]
_OpLimitPatchEnd:
align 16

_DivZeroHook:
	push esi			;VMobj
	push edi			;ops
;	mov eax,[esi+0x2864]
;	mov eax,[eax+4]
;	push eax			;stack
;	push dword [ebp+0x6C]	;fstack
	call _DivZeroHandler
	add esp,8			;clean stack

;Code that was overwritten by patch
	pop eax		; save return address
	pop edi		;1 byte
	pop esi		;1 byte
	push eax
	mov eax,0x7	;5 bytes

	ret

align 16

_DivZeroPatch:
    call [pDivZeroHook]	;6 bytes
    nop				;1 byte
_DivZeroPatchEnd:

align 16

_VarUseHook:
	push esi
	push edi
	call _VarUseHandler
	add esp,8

	pop eax
	pop edi
	pop esi
	push eax
	mov eax,0x6

	ret

align 16

_VarUsePatch:
	call [pVarUseHook]
	nop
_VarUsePatchEnd:

align 16

_PausePatch:
	xor eax,eax
	nop
_PausePatchEnd:

align 16
