#include "section.h"
#include "warhook.h"
#include "libbs.h"

typedef void *(__stdcall *pSMemAlloc)(unsigned int size, char *tag, unsigned int tag, unsigned int flags);
pSMemAlloc SMemAlloc = NULL;

//typedef CACHESTR *(__thiscall *pchar_to_cache)(VM *obj, char *s);
//typedef NATIVESTR *(__thiscall *pcache_to_nstr)(VM *obj, CACHESTR *x);
typedef CACHESTR (__fastcall *pchar_to_cache)(VM *obj, int edx,char *s);
typedef NATIVESTR *(__fastcall *pcache_to_nstr)(VM *obj, int edx,CACHESTR x);

//typedef char * (__thiscall *pstrget)(Symtable *symtable,int x);
typedef char * (__fastcall *pstrget)(Symtable *symtable,int dummy, int x);
typedef int (__fastcall *pstrmap)(char *s);
//typedef char * (__thiscall *pgetnative)(char *s);
typedef native_info * (__fastcall *pgetnative)(char *s);
//typedef int  (__thiscall *pinternalvm)(VM *obj, opcode *funcstart, int unk1, int maxops, int unk2);
typedef int  (__fastcall *pinternalvm)(VM *obj, int dummy, opcode *funcstart, int unk1, int maxops, int unk2);

unsigned char NativeStrGetPattern[] =
{
	0x56,
	0x8B,0xF1,
	0x8B,0x0D,0x00,0x00,0x00,0x00,
	0x85,0xC9,
	0x57,
	0x74,0x00,
	0x6A,0x01,
	0xE8
};

unsigned char NativeStrGetMask[] =
{
	0xFF,
	0xFF,0xFF,
	0xFF,0xFF,0x00,0x00,0x00,0x00,
	0xFF,0xFF,
	0xFF,
	0xFF,0x00,
	0xFF,0xFF,
	0xFF
};

unsigned char StrGetPattern[] =
{
	0x55,
	0x8B,0xEC,
	0x8B,0x45,0x08,
	0x85,0xC0,
	0x75,0x04,
	0x5D,
	0xC2,0x04,0x00,
	0x8B,0x49,0x08,
	0x8B,0x51,0x08
};

unsigned char *StrGetMask = NULL;

unsigned char GetNativeStructPattern[] =
{
	0x55,
	0x8B,0xEC,
	0x51,
	0x53,
	0x56,
	0x8B,0xF1,
	0x57,
	0xB9,0x05,0x00,0x00,0x00,
	0x89,0x75,0xFC,
	0xE8
};

unsigned char *GetNativeStructMask = NULL;

unsigned char char_to_cachePattern[] =
{
	0x55,
	0x8B,0xEC,
	0x83,0xEC,0x08,
	0x8B,0x81,0x54,0x28,0x00,0x00,
	0x53,
	0x8B,0x5D,0x08,
	0x85,0xDB,
	0x56,
	0x57,
	0x8B,0x78,0x08
};

unsigned char *char_to_cacheMask = NULL;

unsigned char cache_to_nstrPattern[] =
{
	0x55,
	0x8B,0xEC,
	0x8B,0x89,0x70,0x28,0x00,0x00,
	0x8B,0x45,0x08,
	0x8B,0x51,0x08,
	0xC1,0xE0,0x04
};

unsigned char *cache_to_nstrMask = NULL;

//static pinternalvm internalvm = (pinternalvm)0x6F6B3690;
pstrget strget = NULL; //0x6F69DFE0; //in 1.20e
//static pstrmap strmap = (pstrmap)0x6F2A7720;
pgetnative getnativestruct = NULL; //(pgetnative)0x6F69E010;

pchar_to_cache char_to_cache= NULL;//(pchar_to_cache)0x6F6ADC80;
pcache_to_nstr cache_to_nstr= NULL; //(pcache_to_nstr)0x6F6ADC60;
//

pNativeStrGet NativeStrGet = NULL;
//pNativeStrMap NativeStrMap = NULL;

typedef long (__stdcall *pSStrHashHT)(char *s);
pSStrHashHT SStrHashHT;

//size is power of two to use
Hashtable *HTCreate(int size)
{
	Hashtable *HT = (Hashtable *)SMemAlloc(sizeof(Hashtable),"Hashtable",0,0);
	HT->bitmask = (1<<size)-1;
	HT->buckets = (HT_Bucket *)SMemAlloc(sizeof(HT_Bucket)*HT->bitmask,"Hashtable_buckets",0,0);
	for(int i=0;i<HT->bitmask;i++) {
		HT->buckets[i].offset = 8;
		HT->buckets[i].list = NULL;
	}
	return HT;
}

/*
 * does not copy key
 */
/*
void HTInsert(Hashtable *HT, char *key, void *value)
{
	long hash = SStrHashHT(key);
	long i = HT->bitmask & hash;
	HT_Node *cur = HT->buckets[i].list;
	HT_Node *newnode;
	if(cur = NULL) {
		//should use SMemAlloc
		newnode = new HT_Node;
		newnode->hash = hash;
		newnode->parent = &HT->buckets[i];
		newnode->next = NULL;
		newnode->key = key;
		newnode->value = value;
		HT->buckets[i].list = newnode;
		return;
	}
	// continue with usual insert case
}
*/
void *HTLookup(Hashtable *HT, char *key)
{
	long hash = SStrHashHT(key);
	long i = HT->bitmask & hash;
	HT_Node *n = HT->buckets[i].list;

	while(1) {
		if(hash == n->hash && (key == n->key || (strncmp(n->key,key,0x7FFFFFFF)==0))) {
			return n->value;
		}

		n = n->next;
		if(((int)n) <= 0) {
			return NULL;
		}
	}
}


typedef struct {
	char unk[0x18];
	Hashtable h;
} HashtableBox;

#define WAR3NSTABLE 5
typedef HashtableBox *(__fastcall *pWar3_497)(int x);
pWar3_497 War3_497;

void initwarhook(Section &code)
{
	VM vm;
	long offset = (long)&vm.symtable - (long)&vm;
	dprintf("symtable offset: %x\n",offset);
	if(offset != 0x2854) {
		dprintf("error, should be 0x2854\n");
		exit(0);
	}

	War3_497=(pWar3_497)GetProcAddress(GetModuleHandle("war3.exe"),(char *)497);
	dprintf("War3_497: %x\n",War3_497);

	HMODULE storm = GetModuleHandle("storm.dll");
	SMemAlloc=(pSMemAlloc)GetProcAddress(storm,(char *)401);
	dprintf("SMemAlloc: %x\n",SMemAlloc);

	SStrHashHT=(pSStrHashHT)GetProcAddress(storm,(char *)590);
	dprintf("SStrHashHT: %x\n",SStrHashHT);

	NativeStrGet = (pNativeStrGet)code.Search(NativeStrGetPattern,NativeStrGetMask,sizeof(NativeStrGetPattern));
	dprintf("NativeStrGet: %x\n",NativeStrGet);


	strget = (pstrget)code.Search(StrGetPattern,StrGetMask,sizeof(StrGetPattern));
	dprintf("strget: %x\n", strget);
	
	getnativestruct = (pgetnative)code.Search(GetNativeStructPattern,GetNativeStructMask,sizeof(GetNativeStructPattern));
	dprintf("getnativestruct: %x\n", getnativestruct);

	char_to_cache = (pchar_to_cache)code.Search(char_to_cachePattern,char_to_cacheMask,sizeof(char_to_cachePattern));
	dprintf("char_to_cache: %x\n", char_to_cache);
	cache_to_nstr = (pcache_to_nstr)code.Search(cache_to_nstrPattern,cache_to_nstrMask,sizeof(cache_to_nstrPattern));
	dprintf("cache_to_nstr: %x\n", cache_to_nstr);
}

char *getfuncname(VM *vm,opcode *ops)
{
	for(;ops->optype != OP_FUNCTION;ops--) {}
	return vm->symtable->Get(ops->arg);
}

Hashtable *GetHashtable(int x)
{
	return &War3_497(x)->h;
}

/*
 * Hash table seems to be different from that for JASS function names
 * It uses the same Hashtable, same bucket with same offset = 8
 * But the nodes must be set up differently, even though they seem generic.
 */
void *GetNativeAddress(char *name)
{
//	native_info *ni = (native_info *)HTLookup(GetHashtable(WAR3NSTABLE),name);
	native_info *ni = getnativestruct(name);
	return (void *)ni->address;
}

NATIVESTR *VM::NativeStrMap(char *s)
{
//	return ::cache_to_nstr(this,0,char_to_cache(this,0,s));
//	dprintf("cache_to_nstr: %x %x\n",this,(long)&nstable-(long)this);
	return cache_to_nstr(char_to_cache(this,0,s));
}

NATIVESTR *VM::cache_to_nstr(CACHESTR c)
{
	return &nstable->ns[c.z];
}

char *Symtable::Get(int x)
{
//	if(x == 0) return NULL;
//	else return s1->js[x]->str;

	return strget(this,0,x);
}


