/*
 * Bryan Steinbach aka PipeDream
 * Last modified 2/25/07
 */

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "wehack.h"
#include "menu.h"

#include "section.h"
#include "iat.h"

FILE *fout;
void dprintf(char *format,...)
{
	va_list args;
	va_start(args,format);
	vfprintf(fout,format,args);
	fflush(fout);
}

typedef BOOL (__stdcall *pChooseFont)(
    LPCHOOSEFONT lpcf
);
pChooseFont dynChooseFont;


typedef HGDIOBJ (__stdcall *pSelectObject)(
  HDC hdc,          // handle to DC
  HGDIOBJ hgdiobj   // handle to object
);

pSelectObject dynSelectObject;

typedef HFONT (__stdcall* pCreateFontIndirectA)(
  CONST LOGFONT* lplf   // characteristics
);

pCreateFontIndirectA dynCreateFontIndirectA;


typedef BOOL (__stdcall *pSFileLoadFile)(LPCSTR lpszFileName, LPVOID *lplpFileData, LPDWORD lpnFileSize, DWORD nExtraBytesToAllocateAtEnd, LPOVERLAPPED lpOverlapped);

typedef BOOL (__stdcall *pSFileUnloadFile)(LPVOID filedata);

typedef BOOL (__stdcall * pSFileOpenArchive)(char *fn, long prio, long flags, long *mpq);
typedef BOOL (__stdcall * pSFileCloseArchive)(long mpq);

pSFileLoadFile SFileLoadFile = NULL;
pSFileUnloadFile SFileUnloadFile = NULL;
pSFileOpenArchive SFileOpenArchive;
pSFileCloseArchive SFileCloseArchive;

HANDLE jassh = NULL;
char *jasspath = NULL;

DWORD mapvalid=true;

enum MenuID { ID_SYNDISABLE=0xbeef,ID_NOLIMITS,ID_COMPILER_ON,ID_COMPILER_DEBUG,ID_PRE_OFF,ID_DESCPOPUP,
	ID_AUTODISABLE,ID_ALWAYSENABLE,ID_IMPPREFIX,ID_VARPREFIX,
	ID_OPENGL, ID_WINDOW, ID_TESTMAP,ID_SELECTFONT,ID_COMPILER_CONFIG };

HWND worldeditclass;

typedef LRESULT (CALLBACK *WndProc_t)(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

WndProc_t oldWndProc;

HMENU GrimoireMenu;
MenuItem *testmap=NULL;
MenuItem *window=NULL;
MenuItem *opengl=NULL;
MenuItem *nolimits=NULL;
MenuItem *syndisable=NULL;
MenuItem *descpopup=NULL;
MenuItem *autodisable=NULL;
MenuItem *always=NULL;
MenuItem *impprefix=NULL;
MenuItem *varprefix=NULL;
MenuItem *selectfont=NULL;

HMENU CompilerMenu;
MenuItem *compileron=NULL;
MenuItem *compilerdebug=NULL;
MenuItem *preprocoff=NULL;
MenuItem *compilerconf=NULL;

void patchbytes(void *dest, void *src, int len)
{
	DWORD old;
	DWORD old2;
	if(!VirtualProtect(dest,len,PAGE_READWRITE,&old)) throw("couldn't set perms");
	memmove(dest,src,len);
	if(!VirtualProtect(dest,len,old,&old2)) throw("couldn't restore perms");
}

int fexists(char *s)
{
	int exists;
	FILE *f = fopen(s,"r");
	if(f!=NULL) {
		exists = true;
		fclose(f);
	}else {
		exists = false;
	}
	return exists;
}


unsigned char *SyntaxDisableAddress;
unsigned char SyntaxDisableBackup[sizeof(SyntaxDisablePatch)];
void hack_SyntaxDisable(int enable)
{
	if(enable) {
		memcpy(SyntaxDisableBackup,SyntaxDisableAddress,sizeof(SyntaxDisablePatch));
		patchbytes(SyntaxDisableAddress,SyntaxDisablePatch,sizeof(SyntaxDisablePatch));
	} else {
		patchbytes(SyntaxDisableAddress,SyntaxDisableBackup,sizeof(SyntaxDisablePatch));
	}
}

unsigned char *DescriptionPopupAddress;
unsigned char DescriptionPopupBackup[sizeof(DescriptionPopupPatch)];
void hack_DescriptionPopup(int enable)
{
	if(enable) {
		memcpy(DescriptionPopupBackup,DescriptionPopupAddress,sizeof(DescriptionPopupPatch));
		patchbytes(DescriptionPopupAddress,DescriptionPopupPatch,sizeof(DescriptionPopupPatch));
	} else {
		patchbytes(DescriptionPopupAddress,DescriptionPopupBackup,sizeof(DescriptionPopupPatch));
	}
}

unsigned char *AutoDisableAddress;
unsigned char AutoDisableBackup[sizeof(AutoDisablePatch)];
void hack_AutoDisable(int enable)
{
	if(enable) {
		memcpy(AutoDisableBackup,AutoDisableAddress,sizeof(AutoDisablePatch));
		patchbytes(AutoDisableAddress,AutoDisablePatch,sizeof(AutoDisablePatch));
	} else {
		patchbytes(AutoDisableAddress,AutoDisableBackup,sizeof(AutoDisablePatch));
	}
}

unsigned char *AlwaysEnableAddress;
unsigned char *AlwaysEnableAddress2;

unsigned char AlwaysEnableBackup[sizeof(AlwaysEnablePatch)];
unsigned char AlwaysEnableBackup2[sizeof(AlwaysEnablePatch2)];
void hack_AlwaysEnable(int enable)
{
	if(enable) {
		memcpy(AlwaysEnableBackup,AlwaysEnableAddress,sizeof(AlwaysEnablePatch));
		patchbytes(AlwaysEnableAddress,AlwaysEnablePatch,sizeof(AlwaysEnablePatch));
	} else {
		patchbytes(AlwaysEnableAddress,AlwaysEnableBackup,sizeof(AlwaysEnablePatch));
	}
	if(enable) {
		memcpy(AlwaysEnableBackup2,AlwaysEnableAddress2+AlwaysEnableOffset2,sizeof(AlwaysEnablePatch2));
		patchbytes(AlwaysEnableAddress2+AlwaysEnableOffset2,AlwaysEnablePatch2,sizeof(AlwaysEnablePatch2));
	} else {
		patchbytes(AlwaysEnableAddress2+AlwaysEnableOffset2,AlwaysEnableBackup2,sizeof(AlwaysEnablePatch2));
	}
}

unsigned char *ImpPrefixAddress;
unsigned char ImpPrefixBackup[sizeof(ImpPrefixPatch)];
void hack_ImpPrefix(int enable)
{
	if(enable) {
		memcpy(ImpPrefixBackup,ImpPrefixAddress,sizeof(ImpPrefixPatch));
		patchbytes(ImpPrefixAddress,ImpPrefixPatch,sizeof(ImpPrefixPatch));
	} else {
		patchbytes(ImpPrefixAddress,ImpPrefixBackup,sizeof(ImpPrefixPatch));
	}
}

unsigned char *DoodadLimitAddress;
unsigned char DoodadLimitBackup[sizeof(DoodadLimitPatch)] = { 0x7E };
void hack_DoodadLimit(int enable)
{
	if(enable) {
		//memcpy(DoodadLimitBackup,DoodadLimitAddress,sizeof(DoodadLimitPatch));
		patchbytes(DoodadLimitAddress,DoodadLimitPatch,sizeof(DoodadLimitPatch));
	} else {
		patchbytes(DoodadLimitAddress,DoodadLimitBackup,sizeof(DoodadLimitPatch));
	}
}

unsigned char *UnitItemLimitAddress;
unsigned char UnitItemLimitBackup[sizeof(UnitItemLimitPatch)] = {0x0F,0x8E,0x9F,0x00,0x00,0x00};
void hack_UnitItemLimit(int enable)
{
	if(enable) {
		//memcpy(UnitItemLimitBackup,UnitItemLimitAddress,sizeof(UnitItemLimitPatch));
		patchbytes(UnitItemLimitAddress,UnitItemLimitPatch,sizeof(UnitItemLimitPatch));
	} else {
		patchbytes(UnitItemLimitAddress,UnitItemLimitBackup,sizeof(UnitItemLimitPatch));
	}
}

unsigned char *MapSizeLimitAddress;
unsigned char MapSizeLimitBackup[sizeof(MapSizeLimitPatch)] = {0x8B};
void hack_MapSizeLimit(int enable)
{
	if(enable) {
		//memcpy(MapSizeLimitBackup,MapSizeLimitAddress,sizeof(MapSizeLimitPatch));
		patchbytes(MapSizeLimitAddress,MapSizeLimitPatch,sizeof(MapSizeLimitPatch));
	} else {
		patchbytes(MapSizeLimitAddress,MapSizeLimitBackup,sizeof(MapSizeLimitPatch));
	}
}

void configcompiler();

LRESULT CALLBACK WndProcWrap(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	/*
	LOGFONT lf;
	CHOOSEFONT f;
	BOOL b;
	f.lStructSize = sizeof(CHOOSEFONT);
	f.hwndOwner = worldeditclass;
	f.hDC = 0;
	f.lpLogFont = &lf;
	f.iPointSize = 0;
	f.Flags = CF_SCREENFONTS;
	f.rgbColors = 0;
	f.lCustData = 0;
	f.lpfnHook = NULL;
	f.lpTemplateName = 0;
	f.hInstance = 0;
	f.lpszStyle = NULL;
	f.nFontType = REGULAR_FONTTYPE;
	f.nSizeMin = 0;
	f.nSizeMax = 0;
*/

	if(message == WM_COMMAND) { 
		switch(wParam) {
			case ID_NOLIMITS:
				nolimits->Toggle();
				hack_DoodadLimit(nolimits->GetCheck());
				hack_UnitItemLimit(nolimits->GetCheck());
				hack_MapSizeLimit(nolimits->GetCheck());
				SaveConf();
				dprintf("Toggling NoLimits\n");
				break;
			case ID_SYNDISABLE:
				syndisable->Toggle();
				hack_SyntaxDisable(syndisable->GetCheck());
				SaveConf();
				dprintf("Toggling syntax checking\n");
				break;
			case ID_DESCPOPUP:
				descpopup->Toggle();
				hack_DescriptionPopup(descpopup->GetCheck());
				SaveConf();
				dprintf("Toggling description nag\n");
				break;
			case ID_AUTODISABLE:
				autodisable->Toggle();
				hack_AutoDisable(autodisable->GetCheck());
				SaveConf();
				dprintf("Toggling auto trigger disable on error\n");
				break;
			case ID_ALWAYSENABLE:
				always->Toggle();
				hack_AlwaysEnable(always->GetCheck());
				SaveConf();
				dprintf("Toggling forced trigger enabling\n");
				break;
/*			case ID_IMPPREFIX:
				impprefix->Toggle();
				hack_ImpPrefix(impprefix->GetCheck());
				SaveConf();
				dprintf("Disable war3mapImported\\ prefix\n");
				break;*/
			case ID_OPENGL:
				opengl->Toggle();
				SaveConf();
				dprintf("Toggled opengl mode\n");
				break;
			case ID_WINDOW:
				window->Toggle();
				SaveConf();
				dprintf("Toggled window mode\n");
				break;
				/*
			case ID_SELECTFONT:
				b = dynChooseFont(&f);
				dprintf("b: %x\n",b);
				break;
				*/
			case ID_COMPILER_ON:
				compileron->Toggle();
				SaveConf();
				dprintf("Toggled compiler on\n");
				break;
			case ID_COMPILER_DEBUG:
				compilerdebug->Toggle();
				SaveConf();
				dprintf("Toggled compiler debug\n");
				break;
			case ID_PRE_OFF:
				preprocoff->Toggle();
				SaveConf();
				dprintf("Toggled preprocoff\n");
				break;
			case ID_COMPILER_CONFIG:
				dprintf("Configured compiler\n");
				configcompiler();
				break;
			case ID_TESTMAP:
				testmap->Toggle();
				SaveConf();
				dprintf("Toggled testmap\n");
				break;
			/*case ID_VARPREFIX:
				varprefix->Toggle();
				hack_varprefix(varprefix->GetCheck());
				dprintf("toggling varprefix\n");

				break;*/
		}
	}
	return oldWndProc(hWnd,message,wParam,lParam);
}





void eatquote(char *s)
{
	int i;
	int quotes=0;
	for(i=0;quotes<2;i++) {
		if(s[i] == '"') quotes++;
	}
	memmove(s,&s[i],strlen(&s[i])+1);
}

void configcompiler()
{
	STARTUPINFO si;
	ZeroMemory(&si,sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO);
	PROCESS_INFORMATION pi;
	ZeroMemory(&pi,sizeof(PROCESS_INFORMATION));
	CreateProcessA(NULL,"mapcompiler --configure",NULL,NULL,false,CREATE_NO_WINDOW,NULL,NULL,&si,&pi);
}

BOOL __stdcall CreateProcessAWrap(char *appname, char *cmdline, LPSECURITY_ATTRIBUTES procattrib, LPSECURITY_ATTRIBUTES threadattrib,BOOL bInherit, DWORD flags, LPVOID env, char *directory, LPSTARTUPINFO info, LPPROCESS_INFORMATION procinfo)
{
	if(compileron->GetCheck() && !mapvalid) return true;	//only start game if map is valid

	char opts[1024];
	strcpy(opts,cmdline);
	if(opengl->GetCheck()) strcat(opts," -opengl");
	if(window->GetCheck()) strcat(opts," -window"); //C string stupidity here



	if(testmap->GetCheck()) {
		char buf[1024];
		eatquote(opts);
		sprintf(buf,"startwar3.bat %s",opts);
		dprintf("createprocess args: %s\n",buf);
		return CreateProcessA("startwar3.bat",buf,procattrib,threadattrib,bInherit,CREATE_NO_WINDOW,env,directory,info,procinfo);
	}
	else return CreateProcessA(appname,opts,procattrib,threadattrib,bInherit,flags,env,directory,info,procinfo);

}

static HFONT newfont;
/*
void setfont()
{
	if(strcmpi("EDIT",lpClassName)==0) {
		HDC dc;
		dc = GetDC(window);
		//SelectFont(dc,newfont);
		dynSelectObject(dc,(HGDIOBJ)newfont);
		ReleaseDC(window,dc);
		dprintf("Changed font\n");
	}
}
*/
HWND __stdcall CreateWindowExAWrap(DWORD dwExStyle,LPCSTR lpClassName,LPCSTR lpWindowName,DWORD dwStyle,int X,int Y,int nWidth,int nHeight,HWND hWndParent,HMENU hMenu,HINSTANCE hInstance,LPVOID lpParam)
{
	HWND window = CreateWindowExA(dwExStyle,lpClassName,lpWindowName,dwStyle,X,Y,nWidth,nHeight,hWndParent,hMenu,hInstance,lpParam);
	if(strcmpi("Warcraft III",lpClassName) == 0) {
		worldeditclass = window;

		dprintf("Editor window caught: %x\n",worldeditclass);
	}
	return window;
}

BOOL __stdcall SetMenuWrap(HWND hWnd, HMENU hMenu)
{
	BOOL success;
	if(hWnd == worldeditclass) {

		GrimoireMenu = CreateMenu();
		AppendMenu(hMenu,MF_STRING|MF_POPUP,(UINT_PTR)GrimoireMenu,"Grimoire");
		syndisable = new MenuItem(worldeditclass,GrimoireMenu,ID_SYNDISABLE,"Disable WE syntax checker");
		nolimits = new MenuItem(worldeditclass,GrimoireMenu,ID_NOLIMITS,"Disable unit, item, doodad and map size limits");
		descpopup = new MenuItem(worldeditclass,GrimoireMenu,ID_DESCPOPUP,"Disable default description nag");
		autodisable = new MenuItem(worldeditclass,GrimoireMenu,ID_AUTODISABLE,"Don't let WE disable a trigger");
		always = new MenuItem(worldeditclass,GrimoireMenu,ID_ALWAYSENABLE,"Force enable triggers with syntax errors (TFT)");
		opengl = new MenuItem(worldeditclass,GrimoireMenu,ID_OPENGL,"use OpenGL for test map");
		window = new MenuItem(worldeditclass,GrimoireMenu,ID_WINDOW,"use Windowed mode for test map");
		testmap = new MenuItem(worldeditclass,GrimoireMenu,ID_TESTMAP,"use startwar3.bat on test map");
		//selectfont = new MenuItem(worldeditclass,GrimoireMenu,ID_SELECTFONT,"select font");
		
		//impprefix = new MenuItem(worldeditclass,GrimoireMenu,ID_IMPPREFIX,"Disable war3mapImported\\ prefix");

		char buf[1024];
		FILE *cname = fopen("jasscompiler.name","r");
		if(cname) {
			fread(buf,1024,1,cname);
			fclose(cname);
		} else {
			sprintf(buf,"Compiler");
		}
		
		CompilerMenu = CreateMenu();
		AppendMenu(hMenu,MF_STRING|MF_POPUP,(UINT_PTR)CompilerMenu,buf);
		compileron = new MenuItem(worldeditclass,CompilerMenu,ID_COMPILER_ON,"Compile war3map.j");
		compilerdebug = new MenuItem(worldeditclass,CompilerMenu,ID_COMPILER_DEBUG,"Compiler debug mode");
		preprocoff = new MenuItem(worldeditclass,CompilerMenu,ID_PRE_OFF,"Disable preprocessor");
		compilerconf = new MenuItem(worldeditclass,CompilerMenu,ID_COMPILER_CONFIG,"Configure mapcompiler");
		

		//varprefix = new MenuItem(worldeditclass,GrimoireMenu,ID_VARPREFIX,"Disable udg_ prefix");
		
		LoadConf();

		success = SetMenu(hWnd,hMenu);
		oldWndProc = (WndProc_t)GetWindowLong(worldeditclass,GWL_WNDPROC);
		SetWindowLong(worldeditclass,GWL_WNDPROC,(LONG)WndProcWrap);
	}
	else success = SetMenu(hWnd,hMenu);
	return success;
}



int strendsi(char *main, char *contains)
{
	int len1 = strlen(main);
	int len2 = strlen(contains);
	if (len2 > len1) return false;
	return strcmpi(main+len1-len2,contains)==0;
}

void extractfile(char *dest, char *src)
{
	char *buf;
	DWORD size;
	BOOL ret = SFileLoadFile(src,(LPVOID *)&buf,&size,0,NULL);
	if(!ret) {
		dprintf("Failed to SFileLoadFile %s\n",src);
		return;
	}
	dprintf("size: %d\n",size);
	FILE *out = fopen(dest,"w");
	fwrite(buf,1,size,out);
	fclose(out);
	SFileUnloadFile(buf);
}

void compilemap(char *path)
{
	long map;
	SFileOpenArchive(path,15,0,&map);

	char pwd[1024];
	GetCurrentDirectory(1024,pwd);
	dprintf("path: %s\n",pwd);
	extractfile("common.j","scripts\\common.j");
	extractfile("Blizzard.j","scripts\\Blizzard.j");

	SFileCloseArchive(map);

	dprintf("war3map.j created \n");
/*	
	sprintf(cmdline,"copy %s .",path);
	system(cmdline);*/

	char buf1[1024],buf2[1024];
	sprintf(buf1,"mapcompiler");
	if(compilerdebug->GetCheck())
		sprintf(buf2,"%s --debug",buf1);
	else
		sprintf(buf2,"%s",buf1);

	if(preprocoff->GetCheck())
		sprintf(buf1,"%s --nopreprocessor",buf2);
	else
		sprintf(buf1,"%s",buf2);

	sprintf(buf2,"%s \"%s\"",buf1,path);

	char *cmdline = buf2;

	PROCESS_INFORMATION pi;
	STARTUPINFO si;
	ZeroMemory(&si,sizeof(si));
	ZeroMemory(&pi,sizeof(pi));

	CreateProcess(NULL,cmdline,NULL,NULL,false,CREATE_NO_WINDOW,NULL,NULL,&si,&pi);
	WaitForSingleObject(pi.hProcess,INFINITE);
	GetExitCodeProcess(pi.hProcess,&mapvalid);
	mapvalid = !mapvalid;
	CloseHandle(pi.hProcess);
}
	
int compiletime = false;

HANDLE __stdcall CreateFileAWrapStorm(char *fn,DWORD access, DWORD share, LPSECURITY_ATTRIBUTES sec, DWORD disp, DWORD flags, HANDLE templatef)
{
	static int compiling = false;
	if(!compiling) {
		compiling = true;
		if((strendsi(fn,".w3x")||strendsi(fn,".w3m")) && compiletime) {
			if(compileron->GetCheck()) {
				compilemap(fn);
			}
			compiletime = false;
		}
		compiling = false;
	}
	HANDLE h = CreateFileA(fn,access,share,sec,disp,flags,templatef);
	return h;
}

HANDLE __stdcall CreateFileAWrapWE(char *fn,DWORD access, DWORD share, LPSECURITY_ATTRIBUTES sec, DWORD disp, DWORD flags, HANDLE templatef)
{
	HANDLE h = CreateFileA(fn,access,share,sec,disp,flags,templatef);
	if(strendsi(fn,"war3map.j")){

		compiletime = true;
		/*jassh = h;
		jasspath = fn;*/
	}
	return h;
}
/*
BOOL __stdcall CloseHandleWrap(HANDLE h)
{
	BOOL retval = CloseHandle(h);
	
	if(jassh == NULL || h != jassh) return retval;

	jassh = NULL;

	dprintf("CloseHandle %s\n",jasspath);

	if(compileron->GetCheck()) {
		compilejass();
	}

	return retval;
}*/

void SaveConf()
{
	FILE *conf = fopen("grim.conf","w");
	if(!conf) return;
	int x;

	x = syndisable->GetCheck();
	fwrite(&x,sizeof(int),1,conf);

	x = descpopup->GetCheck();
	fwrite(&x,sizeof(int),1,conf);

	x = autodisable->GetCheck();
	fwrite(&x,sizeof(int),1,conf);

	x = always->GetCheck();
	fwrite(&x,sizeof(int),1,conf);

	x = opengl->GetCheck();
	fwrite(&x,sizeof(int),1,conf);

	x = window->GetCheck();
	fwrite(&x,sizeof(int),1,conf);
	

	x = compileron->GetCheck();
	fwrite(&x,sizeof(int),1,conf);
	x = compilerdebug->GetCheck();
	fwrite(&x,sizeof(int),1,conf);

	x = testmap->GetCheck();
	fwrite(&x,sizeof(int),1,conf);


	x = nolimits->GetCheck();
	fwrite(&x,sizeof(int),1,conf);

/*	x = impprefix->GetCheck();
	fwrite(&x,sizeof(int),1,conf);*/

	fclose(conf);
}

void LoadConf()
{
	FILE *conf = fopen("grim.conf","r");
	if(!conf) return;
	int x;

	fread(&x,sizeof(int),1,conf);
	if(x) {
		hack_SyntaxDisable(true);
		syndisable->Toggle();
	}

	fread(&x,sizeof(int),1,conf);
	if(x) {
		hack_DescriptionPopup(true);
		descpopup->Toggle();
	}

	fread(&x,sizeof(int),1,conf);
	if(x) {
		hack_AutoDisable(true);
		autodisable->Toggle();
	}

	fread(&x,sizeof(int),1,conf);
	if(x) {
		hack_AlwaysEnable(true);
		always->Toggle();
	}

	fread(&x,sizeof(int),1,conf);
	if(x) {
		opengl->Toggle();
	}

	fread(&x,sizeof(int),1,conf);
	if(x) {
		window->Toggle();
	}

	fread(&x,sizeof(int),1,conf);
	if(x) {
		compileron->Toggle();
	}
	fread(&x,sizeof(int),1,conf);
	if(x) {
		compilerdebug->Toggle();
	}

	fread(&x,sizeof(int),1,conf);
	if(x) {
		testmap->Toggle();
	}

	fread(&x,sizeof(int),1,conf);
	if(x) {
		nolimits->Toggle();
	}

/*	fread(&x,sizeof(int),1,conf);
	if(x) {
		hack_ImpPrefix(true);
		impprefix->Toggle();
	}*/




	fclose(conf);
}

void InstallPatches(void)
{
	Section wecode(GetModuleHandle(0),".text\0\0\0");
	SyntaxDisableAddress = wecode.Search(SyntaxDisablePattern,SyntaxDisableMask,sizeof(SyntaxDisablePattern));

	//WeNoLimits
	DoodadLimitAddress = wecode.Search(DoodadLimitPattern,DoodadLimitMask,sizeof(DoodadLimitPattern));
	UnitItemLimitAddress = wecode.Search(UnitItemLimitPattern,UnitItemLimitMask,sizeof(UnitItemLimitPattern));
	MapSizeLimitAddress = wecode.Search(MapSizeLimitPattern,MapSizeLimitMask,sizeof(MapSizeLimitPattern));

	DescriptionPopupAddress = wecode.Search(DescriptionPopupPattern,DescriptionPopupMask,sizeof(DescriptionPopupPattern));
	AutoDisableAddress = wecode.Search(AutoDisablePattern,AutoDisableMask,sizeof(AutoDisablePattern));
	AlwaysEnableAddress = wecode.Search(AlwaysEnablePattern,AlwaysEnableMask,sizeof(AlwaysEnablePattern));
	AlwaysEnableAddress2 = wecode.Search(AlwaysEnablePattern2,AlwaysEnableMask2,sizeof(AlwaysEnablePattern2));

	//Section wedata(GetModuleHandle(0),".data\0\0\0");
	
	//ImpPrefixAddress = wedata.Search(ImpPrefixPattern,ImpPrefixMask,sizeof(ImpPrefixPattern));

	//varprefixaddr = wecode.Search(VarPrefixPattern,VarPrefixMask,sizeof(VarPrefixPattern));
	dprintf("Syntax disable address: %x\n", SyntaxDisableAddress);
	dprintf("Doodad limit address: %x\n", DoodadLimitAddress);
	dprintf("Unit/item limit address: %x\n", UnitItemLimitAddress);
	dprintf("Map size limit address: %x\n", MapSizeLimitAddress);
	dprintf("Description popup address: %x\n", DescriptionPopupAddress);
	dprintf("Auto disable address: %x\n", AutoDisableAddress);
	dprintf("Always Enable address: %x\n", AlwaysEnableAddress);
	dprintf("Always Enable address #2: %x\n", AlwaysEnableAddress2);
	dprintf("ImpPrefix address: %x\n",ImpPrefixAddress);

}

/*
HMODULE __stdcall LoadLibraryAWrap(char *name)
{
	HMODULE dll = LoadLibraryA(name);
	if(strcmpi("game.dll",name) == 0) {
		LoadConf();


	}
	return dll;
}*/

extern "C" BOOL __stdcall DllMain(HMODULE module, DWORD reason, LPVOID reserved)
{
	if(reason == DLL_PROCESS_ATTACH) {
		DisableThreadLibraryCalls(module);

		fout = fopen("welog.txt","w");
		try {
			CIAT iat;
			iat.SetParentModule(GetModuleHandle(NULL));
			if (!iat.LocateForModule("kernel32.dll"))
				throw("Could not locate kernel32.dll");
			if (!iat.RedirectImport("CreateProcessA",(void *)CreateProcessAWrap))
				throw("Could not redirect CreateProcessA");
			if (!iat.RedirectImport("CreateFileA",(void *)CreateFileAWrapWE))
				throw("Could not redirect CreateFileA");
			/*if (!iat.RedirectImport("CloseHandle",(void *)CloseHandleWrap))
				throw("Could not redirect CloseHandle");*/
			/*if(!iat.RedirectImport("LoadLibraryA",LoadLibraryAWrap))
				throw("Could not redirect LoadLibraryA");*/

/*			if(!iat.LocateForModule("storm.dll"))
				throw("Could not locate storm.dll");
			if(!iat.RedirectImport(*/
			
			if (!iat.LocateForModule("user32.dll"))
				throw("Could not locate user32.dll");
			if(!iat.RedirectImport("CreateWindowExA",(void *)CreateWindowExAWrap))
				throw("Could not redirect CreateWindowExA");
			if(!iat.RedirectImport("SetMenu",(void *)SetMenuWrap))
				throw("Could not redirect SetMenu");

			iat.SetParentModule(GetModuleHandle("storm.dll"));
			if (!iat.LocateForModule("kernel32.dll"))
				throw("Could not locate kernel32.dll");
			if (!iat.RedirectImport("CreateFileA",(void *)CreateFileAWrapStorm))
				throw("Could not redirect CreateFileA");

			SFileLoadFile = (pSFileLoadFile)GetProcAddress(GetModuleHandle("storm.dll"),(char *)0x117);
			SFileUnloadFile = (pSFileUnloadFile)GetProcAddress(GetModuleHandle("storm.dll"),(char *)0x118);
			SFileOpenArchive = (pSFileOpenArchive)GetProcAddress(GetModuleHandle("storm.dll"),(char *)0x10A);
			SFileCloseArchive = (pSFileCloseArchive)GetProcAddress(GetModuleHandle("storm.dll"),(char *)0xFC);
			
			dprintf("SFileLoadFile: %x\n",SFileLoadFile);
			dprintf("SFileUnloadFile: %x\n",SFileUnloadFile);
			dprintf("SFileOpenArchive: %x\n",SFileOpenArchive);
			dprintf("SFileCloseArchive: %x\n",SFileCloseArchive);
			
			InstallPatches();

			dprintf("Redirected ok\n");
/*
			HMODULE gdi32 = GetModuleHandle("gdi32.dll");
			dprintf("gdi32: %x\n",gdi32);
			dynCreateFontIndirectA = (pCreateFontIndirectA)GetProcAddress(gdi32,"CreateFontIndirectA");
			dynSelectObject = (pSelectObject)GetProcAddress(gdi32,"SelectObject");

			HMODULE comdlg32 = GetModuleHandle("comdlg32.dll");
			dprintf("comdlg32: %x\n",comdlg32);
			dynChooseFont = (pChooseFont)GetProcAddress(comdlg32,"ChooseFontA");
			dprintf("choose font: %x\n",dynChooseFont);
			*/

		} catch (const char *s) {
			dprintf("Error: %s\n",s);
			return false;
		}
	}
	return true;
}
